;;;; -*- Mode: lisp; indent-tabs-mode: nil -*-
;;;
;;; babel-speed.asd --- ASDF system definition for Babel speed measurement.
;;;
;;; Copyright (C) 2007, Luis Oliveira  <loliveira@common-lisp.net>
;;;
;;; Permission is hereby granted, free of charge, to any person
;;; obtaining a copy of this software and associated documentation
;;; files (the "Software"), to deal in the Software without
;;; restriction, including without limitation the rights to use, copy,
;;; modify, merge, publish, distribute, sublicense, and/or sell copies
;;; of the Software, and to permit persons to whom the Software is
;;; furnished to do so, subject to the following conditions:
;;;
;;; The above copyright notice and this permission notice shall be
;;; included in all copies or substantial portions of the Software.
;;;
;;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
;;; EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
;;; MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
;;; NONINFRINGEMENT.  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
;;; HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
;;; WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;;; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
;;; DEALINGS IN THE SOFTWARE.

(defsystem babel-speed
  :description "Speed measurement for Babel."
  :depends-on (babel)
  :components
  ((:module "speed"
    :serial t
    :components
    ((:file "speed")))))

(defclass speed-op (asdf::operation) ())

(defmethod perform ((o speed-op) (c (eql (find-system :babel-speed))))
  (funcall (intern (string '#:run-speed) '#:babel-speed)))

(defmethod operation-done-p ((o speed-op) (c (eql (find-system :babel-speed))))
  nil)

;;; vim: ft=lisp et
